#include "oled.h"
#include "stdlib.h"
#include "oledfont.h"  	 
#include "delay.h"

u8 x_offset=0;

void OLED_WR_Byte(u8 dat,u8 cmd)
{
	u8 i;
	if(cmd)
	  OLED_DC_Set();
	else 
	  OLED_DC_Clr();
	OLED_CS_Clr();
	for(i=0;i<8;i++)
	{
		OLED_SCL_Clr();
		if(dat&0x80)
		   OLED_SDA_Set();
		else 
		   OLED_SDA_Clr();
		OLED_SCL_Set();
		dat<<=1;   
	}				 		  
	OLED_CS_Set();
	OLED_DC_Set();   	  
}




//******************************************************************************
//    ˵OLEDʾеʼַֹ
//    ݣx1,x2  еʼַͽַ
//              y1,y2  еʼַͽַ
//    ֵ  
//******************************************************************************
void OLED_Address_Set1(u16 x1,u16 x2,u16 y1,u16 y2)
{

		OLED_WR_Byte(0x21,OLED_CMD);
		OLED_WR_Byte(x1+x_offset,OLED_CMD);
		OLED_WR_Byte(x2+x_offset,OLED_CMD);
		OLED_WR_Byte(0x22,OLED_CMD);
		OLED_WR_Byte(y1,OLED_CMD);
		OLED_WR_Byte(y2,OLED_CMD);
}



//
void OLED_Clear(u16 x1,u16 y1,u16 x2,u16 y2,u8 color)
{
	u8 j;
	u16 i;
	x1/=2;
	x2/=2;
	OLED_Address_Set1(x1,x2-1,y1,y2-1);
	for(i=x1;i<x2;i++)
	{
		for(j=y1;j<y2;j++)
		{
			OLED_WR_Byte(color,OLED_DATA);
	  }
	}
}

//******************************************************************************
//    ˵OLEDʾַ 
//    ˺÷Χַ2ı  ַ߶ǿȵ2
//    ݣx,y   ʼ
//              chr   Ҫдַ
//              sizey ַ߶ 
//    ֵ  
//******************************************************************************
void OLED_ShowChar(u16 x,u16 y,u8 chr,u8 sizey)
{
	u8 j,c;
	u8 i,temp,DATA1=0;
	u16 num;
	c=chr-' ';
	x/=2;
	OLED_Address_Set1(x,x+sizey/4-1,y,y+sizey-1);
	num=sizey/2*sizey/8;
	for(i=0;i<num;i++)
	{
		if(sizey==16)temp=F8X16[c][i];//8x16ַ
		else if(sizey==32)temp=F16X32[c][i];//16x32ַ
		else if(sizey==48)temp=F24X48[c][i];//24x48ַ
		else return;
		for(j=0;j<4;j++)
		{
			if(temp&0x01)
			{
				DATA1=0x0f;
			}
			temp>>=1;
			if(temp&0x01)
			{
				DATA1|=0xf0;
			}
			temp>>=1;
			OLED_WR_Byte(DATA1,OLED_DATA);
			DATA1=0;
		}
	}
}

//******************************************************************************
//    ˵OLEDʾַ
//    ݣx,y  ʼ
//              *dp  Ҫдַ
//              sizey ַ߶ 
//    ֵ  
//******************************************************************************
void OLED_ShowString(u16 x,u16 y,u8 *dp,u8 sizey)
{
	while(*dp!='\0')
	{
	  OLED_ShowChar(x,y,*dp,sizey);
		dp++;
		x+=sizey/2;
	}
}

//******************************************************************************
//    ˵m^n
//    ݣm: n:ָ
//    ֵ  result
//******************************************************************************
u32 oled_pow(u8 m,u8 n)
{
	u32 result=1;
	while(n--)result*=m;    
	return result;
}


//******************************************************************************
//    ˵OLEDʾ
//    ݣx,y :	 
//              len :ֵλ
//              sizey:С
//    ֵ  
//******************************************************************************
void OLED_ShowNum(u16 x,u16 y,u32 num,u8 len,u8 sizey)
{         	
	u8 t,temp;
	u8 enshow=0;
	for(t=0;t<len;t++)
	{
		temp=(num/oled_pow(10,len-t-1))%10;
		if(enshow==0&&t<(len-1))
		{
			if(temp==0)
			{
				OLED_ShowChar(x+(sizey/2)*t,y,' ',sizey);
				continue;
			}else enshow=1; 
		 	 
		}
	 	OLED_ShowChar(x+(sizey/2)*t,y,temp+'0',sizey); 
	}
}

//******************************************************************************
//    ˵OLEDʾ
//    ݣx,y :	 
//              number :ֵ
//              sizey:С
//    ֵ  
//******************************************************************************
void OLED_ShowChinese(u16 x,u16 y,u8 number,u8 sizey)
{
	u8 j;
	u8 temp,DATA1=0;
	u16 i,num;
	x/=2;
	OLED_Address_Set1(x,x+sizey/2-1,y,y+sizey-1);
	num=sizey*sizey/8;
	for(i=0;i<num;i++)
	{
		if(sizey==16)temp=Hz16x16[number][i];//16x16ַ
		else if(sizey==24)temp=F24X24[number][i];//24x24ַ
		else if(sizey==32)temp=F32X32[number][i];//32x32ַ
		else return;
		for(j=0;j<4;j++)
		{
			if(temp&0x01)
			{
				DATA1=0x0f;
			}
			temp>>=1;
			if(temp&0x01)
			{
				DATA1|=0xf0;
			}
			temp>>=1;
			OLED_WR_Byte(DATA1,OLED_DATA);
			DATA1=0;
		}
	}
}

//******************************************************************************
//    ˵OLEDʾͼƬ
//    ݣx,y :
//              sizex,sizey:ͼƬ
//    ֵ  
//******************************************************************************
void OLED_ShowPicture(u16 x,u16 y,u16 sizex,u16 sizey,const u8 bmp[])
{
	u8 DATA1=0;
	u16 i,num;
	x/=2;
	OLED_Address_Set1(x,x+sizex/2-1,y,y+sizey-1);
	num=sizex*sizey/2;
	for(i=0;i<num;i++)
	{
		DATA1=bmp[i];
		OLED_WR_Byte(DATA1,OLED_DATA);
		DATA1=0;
	}
}


//ʼ				    
void OLED_Init(void)
{
	GPIO_InitTypeDef  GPIO_InitStructure;
 	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOG|RCC_APB2Periph_GPIOD|RCC_APB2Periph_GPIOE, ENABLE);	 //ʹA˿ʱ
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12;	 
 	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 		 //
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;//ٶ50MHz
 	GPIO_Init(GPIOG, &GPIO_InitStructure);	  //ʼGPIOG12
 	GPIO_SetBits(GPIOG,GPIO_Pin_12);
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1|GPIO_Pin_4|GPIO_Pin_5|GPIO_Pin_15;
 	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 		 //
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;//ٶ50MHz
 	GPIO_Init(GPIOD, &GPIO_InitStructure);	  //ʼGPIOD1,5,15
 	GPIO_SetBits(GPIOD,GPIO_Pin_1|GPIO_Pin_4|GPIO_Pin_5|GPIO_Pin_15);
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8|GPIO_Pin_10;
 	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 		 //
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;//ٶ50MHz
 	GPIO_Init(GPIOE, &GPIO_InitStructure);	  //ʼGPIOE8,10
 	GPIO_SetBits(GPIOE,GPIO_Pin_8|GPIO_Pin_10);
	
	OLED_RES_Clr();
	delay_ms(200);
	OLED_RES_Set();
	
	OLED_WR_Byte(0xae,OLED_CMD);//Set y Off
	OLED_WR_Byte(0xD5,OLED_CMD);//Set Display Clock Divide Ratio/Oscillator Frequency
	OLED_WR_Byte(0x11,OLED_CMD); 
	OLED_WR_Byte(0xA8,OLED_CMD);//Set Multiplex Ratio 
	OLED_WR_Byte(0x47,OLED_CMD); 
	OLED_WR_Byte(0xA2,OLED_CMD);//Set Display Start Line
	OLED_WR_Byte(0x00,OLED_CMD); 

  if(USE_HORIZONTAL==0)
	{
	 x_offset=0x10;
	 OLED_WR_Byte(0xD3,OLED_CMD);//Set Display Offset
	 OLED_WR_Byte(0x2C,OLED_CMD);
	 OLED_WR_Byte(0xa0,OLED_CMD);//Set COM Output Scan Direction
	 OLED_WR_Byte(0xC8,OLED_CMD); 
	}
	else
	{
	 x_offset=0;
	 OLED_WR_Byte(0xD3,OLED_CMD);//Set Display Offset
	 OLED_WR_Byte(0x74,OLED_CMD);
	 OLED_WR_Byte(0xa1,OLED_CMD);//Set COM Output Scan Direction
	 OLED_WR_Byte(0xC0,OLED_CMD); 
	}
	
	
	OLED_WR_Byte(0xDA,OLED_CMD);//SetSEGPinsHardwareConfiguration
	OLED_WR_Byte(0x32,OLED_CMD);
	

	OLED_WR_Byte(0x81,OLED_CMD);//Set Contrast Control
	OLED_WR_Byte(0xDF,OLED_CMD);

	OLED_WR_Byte(0xD9,OLED_CMD);//SSet Pre-Charge Priod
	OLED_WR_Byte(0x72,OLED_CMD);
	OLED_WR_Byte(0xDB,OLED_CMD);//Set VCOMH Deselect Level 
	OLED_WR_Byte(0x20,OLED_CMD);
	
	
	OLED_WR_Byte(0xAD,OLED_CMD);//Set Internal IREF Enable
	OLED_WR_Byte(0x00,OLED_CMD);
	OLED_WR_Byte(0xBC,OLED_CMD);
	OLED_WR_Byte(0x1E,OLED_CMD); 
	
	OLED_WR_Byte(0xA4,OLED_CMD);//Set Entire Display On/Off
	OLED_WR_Byte(0xA6,OLED_CMD);
	OLED_WR_Byte(0xaf,OLED_CMD);//Display on
}

