//----------------------------------------------------------------------
//EASTRISING TECHNOLOGY CO,.LTD.//
// Module    : ER-OLEDM1.04-1 
// Lanuage   : C Code
// Create    : JAVEN
// Date      : 2025-03-20
// Drive IC  : SSD1320
// INTERFACE : 4 LINE SPI
// MCU 		   : STM32F103ZET6
//----------------------------------------------------------------------

//Hardware connection
// GND    VSS
// VCC    3.3v
// SCK    PG12
// SDA    PD5
// RES    PD4
// DC     PD15
// CS     PD1 


#include "delay.h"
#include "sys.h"
#include "oled.h"
#include "bmp.h"
#include "led.h"
int main(void)
{
	delay_init();
	LED_Init();
	OLED_Init();
	while(1)
	{
		OLED_ShowPicture(0,0,128,72,gImage_1);
		delay_ms(1000);
		OLED_Clear(0,0,128,72,0x00);
		OLED_ShowPicture(0,0,128,72,gImage_2);
		delay_ms(1000);
		OLED_Clear(0,0,128,72,0x00);
		OLED_ShowChinese(24,0,0,16);
		OLED_ShowChinese(42,0,1,16);
		OLED_ShowChinese(60,0,2,16);
		OLED_ShowChinese(78,0,3,16);
		OLED_ShowChinese(96,0,4,16);
		OLED_ShowString(12,18,"buydisplay",16);
		OLED_ShowString(28,36,"EastRising",16);
		OLED_ShowString(32,56,"LEDM0.72-1",16);
		delay_ms(1000);
		OLED_Clear(0,0,128,72,0x00);
	}
}

